//
//  NiddleViewController.m
//  LanoFrai
//
//  Created by Joni Hoppen dos Santos on 27/3/13.
//  Copyright (c) 2013 Aquare.la. All rights reserved.
//

#import "NiddleViewController.h"


@interface NiddleViewController ()

@end

@implementation NiddleViewController
@synthesize degrees, fixLat, fixLon;
@synthesize SoundID;


- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
        
    NSURL *ButtonURL = [NSURL fileURLWithPath:[[NSBundle mainBundle] pathForResource:@"Opendoor"ofType:@"wav"]];
    AudioServicesCreateSystemSoundID((__bridge CFURLRef)ButtonURL, &SoundID);
    
    AudioServicesPlaySystemSound(SoundID);
    

    
    //Cordenatas testadas no MKAnnotation
    fixLat = FIX_LAT;
    fixLon = FIX_LONG;
    
    self.locationManager = [[CLLocationManager alloc] init];
    self.locationManager.delegate = self;
    self.locationManager.desiredAccuracy = kCLLocationAccuracyBest;
    self.locationManager.distanceFilter = kCLDistanceFilterNone;
    self.locationManager.headingFilter = 1;
    [self.locationManager startUpdatingHeading];
    [self.locationManager startUpdatingLocation];
    
    
    //NSLog(@"\n View did load \n");
    
    self.orientationText.text = @"O Frai tá pra lá!";
    
    
    [NSTimer scheduledTimerWithTimeInterval:360.0
                                    target:self
                                  selector:@selector(askStillLost)
                                  userInfo:nil repeats:YES];
}






- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}


- (void) calculateUserAngle:(CLLocationCoordinate2D)current {
    // Destino
    // Latitude - Longitude
    // -27.025095,-50.923838
    
    //Casa
    // Destino
    // Latitude - Longitude
    // -27.591069,-48.542018
    
    double x = 0, y = 0 , deg = 0, delLon = 0;
    
    delLon = fixLon - current.longitude;
    y = sin(delLon) * cos(fixLat);
    x = cos(current.latitude) * sin(fixLat) - sin(current.latitude) * cos(fixLat) * cos(delLon);
    deg = RadiansToDegrees(atan2(y, x));
    
    if(deg<0){
        deg = -deg;
    } else {
        deg = 360 - deg;
    }
    degrees = 0;
    degrees = deg;
    //NSLog(@"Valor dos graus %f:", degrees);
}


- (void)locationManager:(CLLocationManager *)manager didUpdateToLocation:(CLLocation *)newLocation fromLocation:(CLLocation *)oldLocation {
    
    CLLocationCoordinate2D here =  newLocation.coordinate;
    [self calculateUserAngle:here];
    //NSLog(@"Usando a função diduploadlocation")
    
    CLLocation *monumento = [[CLLocation alloc] initWithLatitude:fixLat longitude:fixLon];////here put your destination point
    
    CLLocationDistance distance = [newLocation distanceFromLocation:monumento];
    NSLog(@"Distance to the monument is %2.0f km", distance);
    
    self.lonjura.text = [NSString stringWithFormat:@"%4.0f m", distance];
    
    if (distance < 25000){
        //NSLog(@"distância menor que 12 km");
        self.orientationText.text = @"A chaminé tá lá";
    }
}

- (void)locationManager:(CLLocationManager *)manager didUpdateHeading:(CLHeading *)newHeading
{
    self.niddle.transform = CGAffineTransformMakeRotation((degrees-newHeading.trueHeading) * M_PI / 180);
    //NSLog(@"Kcompasskurs = %f", degrees-newHeading.trueHeading);
}

- (void)viewDidUnload {
    [self setOrientationText:nil];
    [self setLonjura:nil];
    [super viewDidUnload];
}

- (void) askStillLost {
    self.orientationText.text = @"Perdido ainda?";
}


CGFloat DegreesToRadians(CGFloat degrees)
{
    return degrees * M_PI / 180;
};

CGFloat RadiansToDegrees(CGFloat radians)
{
    return radians * 180 / M_PI;
};


@end
